#include <Wire.h>
#include "flprogUtilites.h"
#include <LiquidCrystal_I2C.h>
#include <EEPROM.h>
LiquidCrystal_I2C _lcd1(0x27, 20, 4);
int _dispTempLength1=0;
boolean _isNeedClearDisp1;
const int _menuParametrsArray[]  PROGMEM =  {1, 4, 5, 0, 0, 0, 2, 1, 1, 4, 4, 0, 9, 2, 4, 11, 0, 0, 0, 3, 1, 1, 4, 4, 0, 10, 3, 4, 9, 0, 0, 0, 2, 4, 1, 4, 5, 0, 9, 4, 4, 6, 0, 0, 0, 3, 1, 1, 4, 5, 0, 10, 5, 4, 4, 0, 0, 0, 2, 4, 1, 4, 2, 0, 9, 6, 4, 2, 0, 0, 0, 3, 1, 1, 4, 2, 0, 10, 7, 4, 1, 0, 0, 0, 2, 4, 1, 4, 1, 0, 9, 8, 4, 16, 0, 0, 0, 3, 1, 1, 4, 1, 0, 10, 9, 4, 14, 0, 0, 0, 2, 4, 1, 4, 8, 0, 9, 10, 4, 13, 0, 0, 0, 3, 1, 1, 4, 8, 0, 10, 11, 4, 12, 0, 0, 0, 2, 4, 1, 4, 7, 0, 9, 12, 4, 10, 0, 0, 0, 3, 1, 1, 4, 7, 0, 10, 13, 4, 8, 0, 0, 0, 2, 4, 1, 4, 6, 0, 9, 14, 4, 7, 0, 0, 0, 3, 1, 1, 4, 6, 0, 10, 15, 4, 3, 0, 0, 0, 2, 4, 1, 4, 3, 0, 9, 16, 4, 15, 0, 0, 0, 3, 1, 1, 4, 3, 0, 10};
int _menuValueArray_int[16];
const int _menuConstantValuesArray_int[]  PROGMEM =  {1, 24, 60, 0};
const char _flprogMenuNameString1[] PROGMEM = "LOAD4";
const char _flprogMenuNameString2[] PROGMEM = "LOAD3";
const char _flprogMenuNameString3[] PROGMEM = "LOAD8";
const char _flprogMenuNameString4[] PROGMEM = "LOAD1";
const char _flprogMenuNameString5[] PROGMEM = "LOAD2";
const char _flprogMenuNameString6[] PROGMEM = "LOAD7";
const char _flprogMenuNameString7[] PROGMEM = "LOAD6";
const char _flprogMenuNameString8[] PROGMEM = "LOAD5";
const char _flprogMenuNameString9[] PROGMEM = "H";
const char _flprogMenuNameString10[] PROGMEM = "MIN";
const char* const _flprogMenuStringsArray[] PROGMEM = { _flprogMenuNameString1,  _flprogMenuNameString2,  _flprogMenuNameString3,  _flprogMenuNameString4,  _flprogMenuNameString5,  _flprogMenuNameString6,  _flprogMenuNameString7,  _flprogMenuNameString8,  _flprogMenuNameString9,  _flprogMenuNameString10};
struct _menuItemStricture 
{
     int startInArrayIndex;
}
;
struct _menuMainStricture 
{
    int startIndex;
    int stopIndex;
    bool isSwitchMenuAroundRing;
    _menuItemStricture  currentItem;
}
;
_menuItemStricture _MenuItems[16];
_menuMainStricture _MainMenus[1];
bool _gtv1;
bool _gtv3;
bool _gtv5;
bool _gtv6;
bool _gtv7;
bool _gtv8;
bool _gtv9;
bool _gtv10;
bool _gtv11;
bool _gtv13;
bool _gtv14;
bool _gtv15;
bool _gtv16;
bool _gtv17;
bool _gtv18;
bool _gtv19;
bool _gtv20;
bool _gtv2;
bool _bounseInputD8S = 0;
bool _bounseInputD8O = 0;
unsigned long _bounseInputD8P = 0UL;
bool _SEEPR8OSN = 0;
bool _gen13I = 0;
bool _gen13O = 0;
unsigned long _gen13P = 0UL;
String _Terminal_216591287;
bool _bounseInputD17S = 0;
bool _bounseInputD17O = 0;
unsigned long _bounseInputD17P = 0UL;
int _disp15oldLength = 0;
bool _gen2I = 0;
bool _gen2O = 0;
unsigned long _gen2P = 0UL;
bool _count15I = 0;
int _count15_Value = 0;
int _disp2oldLength = 0;
int _disp9oldLength = 0;
bool _SV6CP0 = 0;
bool _SV6CP0needSend = 0;
bool _SEEPR7OSN = 0;
bool _trgr4 = 0;
bool _SEEPR19OSN = 0;
String _swi5;
bool _SV5CP0 = 0;
bool _SV5CP0needSend = 0;
bool _SEEPR10OSN = 0;
bool _gen21I = 0;
bool _gen21O = 0;
unsigned long _gen21P = 0UL;
bool _gen12I = 0;
bool _gen12O = 0;
unsigned long _gen12P = 0UL;
bool _count3I = 0;
int _count3_Value = 0;
bool _count3MaxLO = 0;
bool _SEEPR6OSN = 0;
String _swi4;
bool _bounseInputD7S = 0;
bool _bounseInputD7O = 0;
unsigned long _bounseInputD7P = 0UL;
bool _SEEPR9OSN = 0;
bool _gen5I = 0;
bool _gen5O = 0;
unsigned long _gen5P = 0UL;
bool _SV1CP0 = 0;
bool _SV1CP0needSend = 0;
bool _count5I = 0;
int _count5_Value = 0;
bool _count5MaxLO = 0;
bool _SEEPR12OSN = 0;
bool _bounseInputD2S = 0;
bool _bounseInputD2O = 0;
unsigned long _bounseInputD2P = 0UL;
bool _gen11I = 0;
bool _gen11O = 0;
unsigned long _gen11P = 0UL;
bool _trgr2 = 0;
int _disp8oldLength = 0;
bool _SV8CP0 = 0;
bool _SV8CP0needSend = 0;
String _Terminal_206604137;
bool _SV7CP0 = 0;
bool _SV7CP0needSend = 0;
bool _count4I = 0;
int _count4_Value = 0;
bool _count9I = 0;
int _count9_Value = 0;
bool _count9MaxLO = 0;
bool _SEEPR11OSN = 0;
bool _gen22I = 0;
bool _gen22O = 0;
unsigned long _gen22P = 0UL;
bool _bounseInputD12S = 0;
bool _bounseInputD12O = 0;
unsigned long _bounseInputD12P = 0UL;
bool _gen15I = 0;
bool _gen15O = 0;
unsigned long _gen15P = 0UL;
bool _gen3I = 0;
bool _gen3O = 0;
unsigned long _gen3P = 0UL;
bool _count17I = 0;
int _count17_Value = 0;
bool _bounseInputD3S = 0;
bool _bounseInputD3O = 0;
unsigned long _bounseInputD3P = 0UL;
bool _count11I = 0;
int _count11_Value = 0;
bool _count11MaxLO = 0;
bool _SEEPR1OSN = 0;
String _Terminal_204939612;
bool _SV3CP0 = 0;
bool _SV3CP0needSend = 0;
bool _gen10I = 0;
bool _gen10O = 0;
unsigned long _gen10P = 0UL;
int _disp11oldLength = 0;
bool _trgr5 = 0;
String _MenuBlock_248462490_ASO_1;
String _MenuBlock_248462490_MNO;
String _MenuBlock_248462490_VNO;
bool _MenuBlock_248462490_OEIS = 0;
bool _MenuBlock_248462490_OMUIS = 0;
bool _MenuBlock_248462490_OMDIS = 0;
bool _MenuBlock_248462490_OVUIS = 0;
bool _MenuBlock_248462490_OVDIS = 0;
bool _SV2CP0 = 0;
bool _SV2CP0needSend = 0;
String _swi1;
bool _bounseInputD6S = 0;
bool _bounseInputD6O = 0;
unsigned long _bounseInputD6P = 0UL;
bool _count1I = 0;
int _count1_Value = 0;
bool _gen17I = 0;
bool _gen17O = 0;
unsigned long _gen17P = 0UL;
bool _count10I = 0;
int _count10_Value = 0;
int _disp12oldLength = 0;
String _Terminal_209933187;
String _Terminal_208268662;
bool _gen23I = 0;
bool _gen23O = 0;
unsigned long _gen23P = 0UL;
int _disp14oldLength = 0;
bool _gen7I = 0;
bool _gen7O = 0;
unsigned long _gen7P = 0UL;
bool _SEEPR2OSN = 0;
bool _bounseInputD11S = 0;
bool _bounseInputD11O = 0;
unsigned long _bounseInputD11P = 0UL;
String _swi6;
bool _gen9I = 0;
bool _gen9O = 0;
unsigned long _gen9P = 0UL;
bool _count7I = 0;
int _count7_Value = 0;
bool _count7MaxLO = 0;
int _disp3oldLength = 0;
bool _trgr3 = 0;
bool _SEEPR14OSN = 0;
bool _SV4CP0 = 0;
bool _SV4CP0needSend = 0;
int _disp17oldLength = 0;
bool _count6I = 0;
int _count6_Value = 0;
bool _gen18I = 0;
bool _gen18O = 0;
unsigned long _gen18P = 0UL;
bool _gen14I = 0;
bool _gen14O = 0;
unsigned long _gen14P = 0UL;
bool _SEEPR13OSN = 0;
String _Terminal_211597712;
int _disp10oldLength = 0;
bool _bounseInputD10S = 0;
bool _bounseInputD10O = 0;
unsigned long _bounseInputD10P = 0UL;
bool _count14I = 0;
int _count14_Value = 0;
bool _count14MaxLO = 0;
int _disp20oldLength = 0;
bool _bounseInputD15S = 0;
bool _bounseInputD15O = 0;
unsigned long _bounseInputD15P = 0UL;
String _swi7;
bool _trgr7 = 0;
bool _trgr6 = 0;
int _disp5oldLength = 0;
bool _SEEPR15OSN = 0;
bool _gen6I = 0;
bool _gen6O = 0;
unsigned long _gen6P = 0UL;
bool _gen1I = 0;
bool _gen1O = 0;
unsigned long _gen1P = 0UL;
int _disp4oldLength = 0;
bool _count13I = 0;
int _count13_Value = 0;
bool _bounseInputD14S = 0;
bool _bounseInputD14O = 0;
unsigned long _bounseInputD14P = 0UL;
bool _Terminal_219153375;
bool _trgr8 = 0;
String _swi2;
bool _gen8I = 0;
bool _gen8O = 0;
unsigned long _gen8P = 0UL;
bool _SEEPR4OSN = 0;
bool _count2I = 0;
bool _count2_SCST = 0;
int _count2_Value = 0;
bool _count2MaxLO = 0;
bool _gen19I = 0;
bool _gen19O = 0;
unsigned long _gen19P = 0UL;
String _Terminal_214926762;
bool _bounseInputD9S = 0;
bool _bounseInputD9O = 0;
unsigned long _bounseInputD9P = 0UL;
int _disp1oldLength = 0;
String _Terminal_213262237;
bool _bounseInputD16S = 0;
bool _bounseInputD16O = 0;
unsigned long _bounseInputD16P = 0UL;
String _swi8;
int _disp16oldLength = 0;
bool _SEEPR3OSN = 0;
bool _gen4I = 0;
bool _gen4O = 0;
unsigned long _gen4P = 0UL;
bool _gen24I = 0;
bool _gen24O = 0;
unsigned long _gen24P = 0UL;
bool _count8I = 0;
int _count8_Value = 0;
bool _count12I = 0;
int _count12_Value = 0;
bool _count12MaxLO = 0;
int _disp6oldLength = 0;
bool _bounseInputD13S = 0;
bool _bounseInputD13O = 0;
unsigned long _bounseInputD13P = 0UL;
bool _Terminal_207235935;
int _disp13oldLength = 0;
bool _trgr1 = 0;
bool _bounseInputD4S = 0;
bool _bounseInputD4O = 0;
unsigned long _bounseInputD4P = 0UL;
bool _gen20I = 0;
bool _gen20O = 0;
unsigned long _gen20P = 0UL;
bool _count16I = 0;
int _count16_Value = 0;
bool _count16MaxLO = 0;
bool _SEEPR5OSN = 0;
String _swi3;
bool _gen16I = 0;
bool _gen16O = 0;
unsigned long _gen16P = 0UL;
bool _tempVariable_bool;
int _tempVariable_int;
void setup()
{
    pinMode(6, INPUT_PULLUP);
    pinMode(5, INPUT_PULLUP);
    pinMode(4, INPUT_PULLUP);
    pinMode(3, INPUT_PULLUP);
    pinMode(2, INPUT_PULLUP);
    pinMode(14, INPUT_PULLUP);
    pinMode(13, INPUT_PULLUP);
    pinMode(12, INPUT_PULLUP);
    pinMode(11, INPUT_PULLUP);
    pinMode(15, INPUT_PULLUP);
    pinMode(16, INPUT_PULLUP);
    pinMode(10, INPUT_PULLUP);
    pinMode(9, INPUT_PULLUP);
    pinMode(8, INPUT_PULLUP);
    pinMode(7, INPUT_PULLUP);
    pinMode(17, INPUT_PULLUP);
    Wire.begin();
    delay(10);
    _startUart0();
    _lcd1.init();
    _lcd1.backlight();
    _bounseInputD14O =    digitalRead(14);
    _bounseInputD17O =    digitalRead(17);
    _bounseInputD7O =    digitalRead(7);
    _bounseInputD12O =    digitalRead(12);
    _bounseInputD13O =    digitalRead(13);
    _bounseInputD6O =    digitalRead(6);
    _bounseInputD11O =    digitalRead(11);
    _bounseInputD10O =    digitalRead(10);
    _bounseInputD2O =    digitalRead(2);
    _bounseInputD15O =    digitalRead(15);
    _bounseInputD9O =    digitalRead(9);
    _bounseInputD16O =    digitalRead(16);
    _bounseInputD8O =    digitalRead(8);
    _bounseInputD3O =    digitalRead(3);
    _bounseInputD4O =    digitalRead(4);
    _MenuItems[0].startInArrayIndex = 0;
    _MenuItems[1].startInArrayIndex = 13;
    _MenuItems[2].startInArrayIndex = 26;
    _MenuItems[3].startInArrayIndex = 39;
    _MenuItems[4].startInArrayIndex = 52;
    _MenuItems[5].startInArrayIndex = 65;
    _MenuItems[6].startInArrayIndex = 78;
    _MenuItems[7].startInArrayIndex = 91;
    _MenuItems[8].startInArrayIndex = 104;
    _MenuItems[9].startInArrayIndex = 117;
    _MenuItems[10].startInArrayIndex = 130;
    _MenuItems[11].startInArrayIndex = 143;
    _MenuItems[12].startInArrayIndex = 156;
    _MenuItems[13].startInArrayIndex = 169;
    _MenuItems[14].startInArrayIndex = 182;
    _MenuItems[15].startInArrayIndex = 195;
    _MainMenus[0].startIndex = 1;
    _MainMenus[0].isSwitchMenuAroundRing = 0;
    _MainMenus[0].stopIndex = 16;
    _MainMenus[0].currentItem = _MenuItems[0];
}
void loop()
{
    if (_isNeedClearDisp1) 
    {
        _lcd1.clear();
        _isNeedClearDisp1= 0;
    }
    bool  _bounceInputTmpD15 =  (digitalRead (15));
    if (_bounseInputD15S)
    {
        if (millis() >= (_bounseInputD15P + 40))
        {
            _bounseInputD15O= _bounceInputTmpD15;
            _bounseInputD15S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD15 != _bounseInputD15O)
        {
            _bounseInputD15S=1;
            _bounseInputD15P = millis();
        }
    }
    bool  _bounceInputTmpD7 =  (digitalRead (7));
    if (_bounseInputD7S)
    {
        if (millis() >= (_bounseInputD7P + 40))
        {
            _bounseInputD7O= _bounceInputTmpD7;
            _bounseInputD7S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD7 != _bounseInputD7O)
        {
            _bounseInputD7S=1;
            _bounseInputD7P = millis();
        }
    }
    bool  _bounceInputTmpD3 =  (digitalRead (3));
    if (_bounseInputD3S)
    {
        if (millis() >= (_bounseInputD3P + 40))
        {
            _bounseInputD3O= _bounceInputTmpD3;
            _bounseInputD3S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD3 != _bounseInputD3O)
        {
            _bounseInputD3S=1;
            _bounseInputD3P = millis();
        }
    }
    bool  _bounceInputTmpD2 =  (digitalRead (2));
    if (_bounseInputD2S)
    {
        if (millis() >= (_bounseInputD2P + 40))
        {
            _bounseInputD2O= _bounceInputTmpD2;
            _bounseInputD2S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD2 != _bounseInputD2O)
        {
            _bounseInputD2S=1;
            _bounseInputD2P = millis();
        }
    }
    bool  _bounceInputTmpD16 =  (digitalRead (16));
    if (_bounseInputD16S)
    {
        if (millis() >= (_bounseInputD16P + 40))
        {
            _bounseInputD16O= _bounceInputTmpD16;
            _bounseInputD16S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD16 != _bounseInputD16O)
        {
            _bounseInputD16S=1;
            _bounseInputD16P = millis();
        }
    }
    bool  _bounceInputTmpD14 =  (digitalRead (14));
    if (_bounseInputD14S)
    {
        if (millis() >= (_bounseInputD14P + 40))
        {
            _bounseInputD14O= _bounceInputTmpD14;
            _bounseInputD14S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD14 != _bounseInputD14O)
        {
            _bounseInputD14S=1;
            _bounseInputD14P = millis();
        }
    }
    bool  _bounceInputTmpD6 =  (digitalRead (6));
    if (_bounseInputD6S)
    {
        if (millis() >= (_bounseInputD6P + 40))
        {
            _bounseInputD6O= _bounceInputTmpD6;
            _bounseInputD6S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD6 != _bounseInputD6O)
        {
            _bounseInputD6S=1;
            _bounseInputD6P = millis();
        }
    }
    bool  _bounceInputTmpD17 =  (digitalRead (17));
    if (_bounseInputD17S)
    {
        if (millis() >= (_bounseInputD17P + 40))
        {
            _bounseInputD17O= _bounceInputTmpD17;
            _bounseInputD17S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD17 != _bounseInputD17O)
        {
            _bounseInputD17S=1;
            _bounseInputD17P = millis();
        }
    }
    bool  _bounceInputTmpD13 =  (digitalRead (13));
    if (_bounseInputD13S)
    {
        if (millis() >= (_bounseInputD13P + 40))
        {
            _bounseInputD13O= _bounceInputTmpD13;
            _bounseInputD13S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD13 != _bounseInputD13O)
        {
            _bounseInputD13S=1;
            _bounseInputD13P = millis();
        }
    }
    bool  _bounceInputTmpD10 =  (digitalRead (10));
    if (_bounseInputD10S)
    {
        if (millis() >= (_bounseInputD10P + 40))
        {
            _bounseInputD10O= _bounceInputTmpD10;
            _bounseInputD10S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD10 != _bounseInputD10O)
        {
            _bounseInputD10S=1;
            _bounseInputD10P = millis();
        }
    }
    bool  _bounceInputTmpD9 =  (digitalRead (9));
    if (_bounseInputD9S)
    {
        if (millis() >= (_bounseInputD9P + 40))
        {
            _bounseInputD9O= _bounceInputTmpD9;
            _bounseInputD9S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD9 != _bounseInputD9O)
        {
            _bounseInputD9S=1;
            _bounseInputD9P = millis();
        }
    }
    bool  _bounceInputTmpD12 =  (digitalRead (12));
    if (_bounseInputD12S)
    {
        if (millis() >= (_bounseInputD12P + 40))
        {
            _bounseInputD12O= _bounceInputTmpD12;
            _bounseInputD12S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD12 != _bounseInputD12O)
        {
            _bounseInputD12S=1;
            _bounseInputD12P = millis();
        }
    }
    bool  _bounceInputTmpD4 =  (digitalRead (4));
    if (_bounseInputD4S)
    {
        if (millis() >= (_bounseInputD4P + 40))
        {
            _bounseInputD4O= _bounceInputTmpD4;
            _bounseInputD4S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD4 != _bounseInputD4O)
        {
            _bounseInputD4S=1;
            _bounseInputD4P = millis();
        }
    }
    bool  _bounceInputTmpD11 =  (digitalRead (11));
    if (_bounseInputD11S)
    {
        if (millis() >= (_bounseInputD11P + 40))
        {
            _bounseInputD11O= _bounceInputTmpD11;
            _bounseInputD11S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD11 != _bounseInputD11O)
        {
            _bounseInputD11S=1;
            _bounseInputD11P = millis();
        }
    }
    bool  _bounceInputTmpD8 =  (digitalRead (8));
    if (_bounseInputD8S)
    {
        if (millis() >= (_bounseInputD8P + 40))
        {
            _bounseInputD8O= _bounceInputTmpD8;
            _bounseInputD8S=0;
        }
    }
    else
    {
        if (_bounceInputTmpD8 != _bounseInputD8O)
        {
            _bounseInputD8S=1;
            _bounseInputD8P = millis();
        }
    }
    //Плата:1
//Наименование:ВКЛ НАГРУЗКИ 1 - 4
     if (!(0)) 
    {
        _tempVariable_bool  =  1;
        if (! _MenuBlock_248462490_OEIS) 
        {
            _MenuBlock_248462490_OEIS = 1;
        }
        _tempVariable_int = pgm_read_byte(&_menuParametrsArray[((_MainMenus[0].currentItem).startInArrayIndex)+10]);
        _MenuBlock_248462490_MNO = _readStringFromProgmem ((char*)pgm_read_word(&(_flprogMenuStringsArray[_tempVariable_int - 1])));
        _MenuBlock_248462490_VNO = _menuOutputValueString (0);
        _tempVariable_int  =  pgm_read_byte(&_menuParametrsArray[(((_MainMenus[0]).currentItem).startInArrayIndex) +12]);
        if(_tempVariable_int == 0) 
        {
            _MenuBlock_248462490_ASO_1 =  "";
        }
         else 
        {
            _MenuBlock_248462490_ASO_1 =  _readStringFromProgmem ((char*)pgm_read_word(&(_flprogMenuStringsArray[_tempVariable_int - 1])));
        }
    }
     else 
    {
        _tempVariable_bool  =  0;
        if (_MenuBlock_248462490_OEIS)
        {
            _MenuBlock_248462490_OEIS = 0;
        }
        _MenuBlock_248462490_ASO_1 =  "";
        _MenuBlock_248462490_MNO = "";
        _MenuBlock_248462490_VNO = "";
    }
    if(!(_bounseInputD6O)) 
    {
         if (! _MenuBlock_248462490_OMUIS) 
        {
            _MenuBlock_248462490_OMUIS = 1;
            if(_tempVariable_bool)
            {
                  _menuUpEvents(0);
            }
        }
    }
     else 
    {
        _MenuBlock_248462490_OMUIS = 0;
    }
    if(!((digitalRead (5)))) 
    {
         if (! _MenuBlock_248462490_OMDIS) 
        {
            _MenuBlock_248462490_OMDIS = 1;
            if(_tempVariable_bool)
            {
                   _menuDownEvents(0);
            }
        }
    }
     else 
    {
        _MenuBlock_248462490_OMDIS = 0;
    }
    if(!(_bounseInputD4O)) 
    {
         if (! _MenuBlock_248462490_OVUIS) 
        {
            _MenuBlock_248462490_OVUIS = 1;
            if(_tempVariable_bool)
            {
                  _valueUpEvents(0);
            }
        }
    }
     else 
    {
        _MenuBlock_248462490_OVUIS = 0;
    }
    if(!(_bounseInputD3O)) 
    {
         if (! _MenuBlock_248462490_OVDIS) 
        {
            _MenuBlock_248462490_OVDIS = 1;
            if(_tempVariable_bool)
            {
                  _valueDownEvents(0);
            }
        }
    }
     else 
    {
        _MenuBlock_248462490_OVDIS = 0;
    }
    if (_gtv3)
    {
        _count2_Value = 0;
    }
     else 
    {
        if (!(_bounseInputD15O))
        {
            if (! _count2I) 
            {
                _count2I = 1;
                _count2_Value = _count2_Value + 1;
            }
        }
         else 
        {
            _count2I = 0;
        }
        if (!(_bounseInputD16O))
        {
            if (! _count2_SCST) 
            {
                _count2_SCST = 1;
                if(_count2_Value > 0) 
                {
                    _count2_Value = _count2_Value - 1;
                }
            }
        }
         else 
        {
            _count2_SCST = 0;
        }
    }
    _count2MaxLO = _count2_Value >= 4;
    _Terminal_207235935 = (_count2_Value) == (1);
    if (_gtv13)
    {
        _count1_Value = 0;
    }
     else 
    {
        if (_gtv1)
        {
            if (! _count1I) 
            {
                _count1I = 1;
                if(_count1_Value < 24) 
                {
                    _count1_Value = _count1_Value + 1;
                }
            }
        }
         else 
        {
            _count1I = 0;
        }
    }
    if(((((!(_bounseInputD11O)) && (!(_bounseInputD17O)))) || (_gtv16))) _trgr3 = 0;
    if(((!(_bounseInputD11O)) && (!(!(_bounseInputD17O))))) _trgr3 = 1;
    if(!((_trgr3)==(_SV4CP0)))
    {
        _SV4CP0needSend = 1;
    }
     _SV4CP0 = _trgr3;
    if (_trgr3) 
    {
         if (! _gen3I) 
        {
            _gen3I = 1;
            _gen3O = 1;
            _gen3P = millis();
        }
    }
     else 
    {
        _gen3I = 0 ;
        _gen3O= 0;
    }
    if (_gen3I) 
    {
          if (flprog::isTimer (_gen3P , 500)) 
        {
             _gen3P = millis();
            _gen3O = ! _gen3O;
        }
    }
    if (((_gtv7) || (((((!(_bounseInputD11O)) && (!(_bounseInputD17O)))) || (_gtv16)))))
    {
        _count7_Value = 0;
    }
     else 
    {
        if (_gen3O)
        {
            if (! _count7I) 
            {
                _count7I = 1;
                _count7_Value = _count7_Value + 1;
            }
        }
         else 
        {
            _count7I = 0;
        }
    }
    _count7MaxLO = _count7_Value >= 60;
    if (_gtv16)
    {
        _count8_Value = 0;
    }
     else 
    {
        if (_gtv7)
        {
            if (! _count8I) 
            {
                _count8I = 1;
                if(_count8_Value < 24) 
                {
                    _count8_Value = _count8_Value + 1;
                }
            }
        }
         else 
        {
            _count8I = 0;
        }
    }
    if ((((_count8_Value) == ((readIntegerFromEEPROM(12, 0, 0x0)))) && ((_count7_Value) == ((readIntegerFromEEPROM(14, 0, 0x0)))))) 
    {
        if (! _gen13I)
        {
            _gen13I = 1;
            _gen13O = 1;
            _gen13P = millis();
        }
    }
     else 
    {
        _gen13I = 0 ;
        _gen13O= 0;
    }
     if (_gen13I &&  _gen13O)   _gen13O = !(flprog::isTimer(_gen13P , 300));
    _gtv16 = _gen13O;
    if (_trgr3) 
    {
         if (! _gen20I) 
        {
            _gen20I = 1;
            _gen20O = 1;
            _gen20P = millis();
        }
    }
     else 
    {
        _gen20I = 0 ;
        _gen20O= 0;
    }
    if (_gen20I) 
    {
          if (flprog::isTimer (_gen20P , 500)) 
        {
             _gen20P = millis();
            _gen20O = ! _gen20O;
        }
    }
    if(_gen20O)
    {
        _swi4=String(" ");
    }
    else
    {
        _swi4=String(":");
    }
    if ((_count2_Value) == (0)) 
    {
        _dispTempLength1 = ((((String("LOAD4 ")) + ((String(_count8_Value, DEC))) + (_swi4) + ((String(_count7_Value, DEC))) + (String("  ")) + (_Terminal_209933187)))).length();
        if (_disp2oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp2oldLength = _dispTempLength1;
        _lcd1.setCursor(0, 3);
        _lcd1.print((((String("LOAD4 ")) + ((String(_count8_Value, DEC))) + (_swi4) + ((String(_count7_Value, DEC))) + (String("  ")) + (_Terminal_209933187))));
    }
     else 
    {
        if (_disp2oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp2oldLength = 0;
        }
    }
    _gtv7 = _count7MaxLO;
    if(((((!(_bounseInputD12O)) && (!(_bounseInputD17O)))) || (_gtv15))) _trgr2 = 0;
    if(((!(_bounseInputD12O)) && (!(!(_bounseInputD17O))))) _trgr2 = 1;
    if(!((_trgr2)==(_SV3CP0)))
    {
        _SV3CP0needSend = 1;
    }
     _SV3CP0 = _trgr2;
    if (_trgr2) 
    {
         if (! _gen2I) 
        {
            _gen2I = 1;
            _gen2O = 1;
            _gen2P = millis();
        }
    }
     else 
    {
        _gen2I = 0 ;
        _gen2O= 0;
    }
    if (_gen2I) 
    {
          if (flprog::isTimer (_gen2P , 500)) 
        {
             _gen2P = millis();
            _gen2O = ! _gen2O;
        }
    }
    if (((_gtv6) || (((((!(_bounseInputD12O)) && (!(_bounseInputD17O)))) || (_gtv15)))))
    {
        _count5_Value = 0;
    }
     else 
    {
        if (_gen2O)
        {
            if (! _count5I) 
            {
                _count5I = 1;
                _count5_Value = _count5_Value + 1;
            }
        }
         else 
        {
            _count5I = 0;
        }
    }
    _count5MaxLO = _count5_Value >= 60;
    if (_gtv15)
    {
        _count6_Value = 0;
    }
     else 
    {
        if (_gtv6)
        {
            if (! _count6I) 
            {
                _count6I = 1;
                if(_count6_Value < 24) 
                {
                    _count6_Value = _count6_Value + 1;
                }
            }
        }
         else 
        {
            _count6I = 0;
        }
    }
    if ((((_count6_Value) == ((readIntegerFromEEPROM(8, 0, 0x0)))) && ((_count5_Value) == ((readIntegerFromEEPROM(10, 0, 0x0)))))) 
    {
        if (! _gen12I)
        {
            _gen12I = 1;
            _gen12O = 1;
            _gen12P = millis();
        }
    }
     else 
    {
        _gen12I = 0 ;
        _gen12O= 0;
    }
     if (_gen12I &&  _gen12O)   _gen12O = !(flprog::isTimer(_gen12P , 300));
    _gtv15 = _gen12O;
    if (_trgr2) 
    {
         if (! _gen19I) 
        {
            _gen19I = 1;
            _gen19O = 1;
            _gen19P = millis();
        }
    }
     else 
    {
        _gen19I = 0 ;
        _gen19O= 0;
    }
    if (_gen19I) 
    {
          if (flprog::isTimer (_gen19P , 500)) 
        {
             _gen19P = millis();
            _gen19O = ! _gen19O;
        }
    }
    if(_gen19O)
    {
        _swi3=String(" ");
    }
    else
    {
        _swi3=String(":");
    }
    if ((_count2_Value) == (0)) 
    {
        _dispTempLength1 = ((((String("LOAD3 ")) + ((String(_count6_Value, DEC))) + (_swi3) + ((String(_count5_Value, DEC))) + (String("  ")) + (_Terminal_208268662)))).length();
        if (_disp1oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp1oldLength = _dispTempLength1;
        _lcd1.setCursor(0, 2);
        _lcd1.print((((String("LOAD3 ")) + ((String(_count6_Value, DEC))) + (_swi3) + ((String(_count5_Value, DEC))) + (String("  ")) + (_Terminal_208268662))));
    }
     else 
    {
        if (_disp1oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp1oldLength = 0;
        }
    }
    _gtv6 = _count5MaxLO;
    if(((((!(_bounseInputD13O)) && (!(_bounseInputD17O)))) || (_gtv14))) _trgr1 = 0;
    if(((!(_bounseInputD13O)) && (!(!(_bounseInputD17O))))) _trgr1 = 1;
    if(!((_trgr1)==(_SV2CP0)))
    {
        _SV2CP0needSend = 1;
    }
     _SV2CP0 = _trgr1;
    if (_trgr1) 
    {
         if (! _gen1I) 
        {
            _gen1I = 1;
            _gen1O = 1;
            _gen1P = millis();
        }
    }
     else 
    {
        _gen1I = 0 ;
        _gen1O= 0;
    }
    if (_gen1I) 
    {
          if (flprog::isTimer (_gen1P , 500)) 
        {
             _gen1P = millis();
            _gen1O = ! _gen1O;
        }
    }
    if (((_gtv5) || (((((!(_bounseInputD13O)) && (!(_bounseInputD17O)))) || (_gtv14)))))
    {
        _count3_Value = 0;
    }
     else 
    {
        if (_gen1O)
        {
            if (! _count3I) 
            {
                _count3I = 1;
                _count3_Value = _count3_Value + 1;
            }
        }
         else 
        {
            _count3I = 0;
        }
    }
    _count3MaxLO = _count3_Value >= 60;
    if (_gtv14)
    {
        _count4_Value = 0;
    }
     else 
    {
        if (_gtv5)
        {
            if (! _count4I) 
            {
                _count4I = 1;
                if(_count4_Value < 24) 
                {
                    _count4_Value = _count4_Value + 1;
                }
            }
        }
         else 
        {
            _count4I = 0;
        }
    }
    if ((((_count4_Value) == ((readIntegerFromEEPROM(4, 0, 0x0)))) && ((_count3_Value) == ((readIntegerFromEEPROM(6, 0, 0x0)))))) 
    {
        if (! _gen11I)
        {
            _gen11I = 1;
            _gen11O = 1;
            _gen11P = millis();
        }
    }
     else 
    {
        _gen11I = 0 ;
        _gen11O= 0;
    }
     if (_gen11I &&  _gen11O)   _gen11O = !(flprog::isTimer(_gen11P , 300));
    _gtv14 = _gen11O;
    if (_trgr1) 
    {
         if (! _gen18I) 
        {
            _gen18I = 1;
            _gen18O = 1;
            _gen18P = millis();
        }
    }
     else 
    {
        _gen18I = 0 ;
        _gen18O= 0;
    }
    if (_gen18I) 
    {
          if (flprog::isTimer (_gen18P , 500)) 
        {
             _gen18P = millis();
            _gen18O = ! _gen18O;
        }
    }
    if(_gen18O)
    {
        _swi2=String(" ");
    }
    else
    {
        _swi2=String(":");
    }
    if ((_count2_Value) == (0)) 
    {
        _dispTempLength1 = ((((String("LOAD2 ")) + ((String(_count4_Value, DEC))) + (_swi2) + ((String(_count3_Value, DEC))) + (String("  ")) + (_Terminal_206604137)))).length();
        if (_disp16oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp16oldLength = _dispTempLength1;
        _lcd1.setCursor(0, 1);
        _lcd1.print((((String("LOAD2 ")) + ((String(_count4_Value, DEC))) + (_swi2) + ((String(_count3_Value, DEC))) + (String("  ")) + (_Terminal_206604137))));
    }
     else 
    {
        if (_disp16oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp16oldLength = 0;
        }
    }
    _gtv5 = _count3MaxLO;
    if(((((!(_bounseInputD14O)) && (!(_bounseInputD17O)))) || (_gtv13))) _trgr6 = 0;
    if(((!(_bounseInputD14O)) && (!(!(_bounseInputD17O))))) _trgr6 = 1;
    if (_trgr6) 
    {
         if (! _gen17I) 
        {
            _gen17I = 1;
            _gen17O = 1;
            _gen17P = millis();
        }
    }
     else 
    {
        _gen17I = 0 ;
        _gen17O= 0;
    }
    if (_gen17I) 
    {
          if (flprog::isTimer (_gen17P , 500)) 
        {
             _gen17P = millis();
            _gen17O = ! _gen17O;
        }
    }
    if(_gen17O)
    {
        _swi1=String(" ");
    }
    else
    {
        _swi1=String(":");
    }
    if(!((_trgr6)==(_SV1CP0)))
    {
        _SV1CP0needSend = 1;
    }
     _SV1CP0 = _trgr6;
    if (_trgr6) 
    {
         if (! _gen6I) 
        {
            _gen6I = 1;
            _gen6O = 1;
            _gen6P = millis();
        }
    }
     else 
    {
        _gen6I = 0 ;
        _gen6O= 0;
    }
    if (_gen6I) 
    {
          if (flprog::isTimer (_gen6P , 500)) 
        {
             _gen6P = millis();
            _gen6O = ! _gen6O;
        }
    }
    if (((_gtv1) || (((((!(_bounseInputD14O)) && (!(_bounseInputD17O)))) || (_gtv13)))))
    {
        _count12_Value = 0;
    }
     else 
    {
        if (_gen6O)
        {
            if (! _count12I) 
            {
                _count12I = 1;
                _count12_Value = _count12_Value + 1;
            }
        }
         else 
        {
            _count12I = 0;
        }
    }
    _count12MaxLO = _count12_Value >= 60;
    _gtv1 = _count12MaxLO;
    if ((((_count1_Value) == ((readIntegerFromEEPROM(0, 0, 0x0)))) && ((_count12_Value) == ((readIntegerFromEEPROM(2, 0, 0x0)))))) 
    {
        if (! _gen10I)
        {
            _gen10I = 1;
            _gen10O = 1;
            _gen10P = millis();
        }
    }
     else 
    {
        _gen10I = 0 ;
        _gen10O= 0;
    }
     if (_gen10I &&  _gen10O)   _gen10O = !(flprog::isTimer(_gen10P , 300));
    _gtv13 = _gen10O;
    if ((_count2_Value) == (0)) 
    {
        _dispTempLength1 = ((((String("LOAD1 ")) + ((String(_count1_Value, DEC))) + (_swi1) + ((String(_count12_Value, DEC))) + (String("  ")) + (_Terminal_204939612)))).length();
        if (_disp20oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp20oldLength = _dispTempLength1;
        _lcd1.setCursor(0, 0);
        _lcd1.print((((String("LOAD1 ")) + ((String(_count1_Value, DEC))) + (_swi1) + ((String(_count12_Value, DEC))) + (String("  ")) + (_Terminal_204939612))));
    }
     else 
    {
        if (_disp20oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp20oldLength = 0;
        }
    }
    _gtv3 = _count2MaxLO;
    _Terminal_219153375 = (_count2_Value) == (2);
    if ((_count2_Value) == (2)) 
    {
        _dispTempLength1 = ((((_MenuBlock_248462490_MNO) + (String(" ")) + (_MenuBlock_248462490_VNO) + (String(" ")) + (_MenuBlock_248462490_ASO_1) + (String(" ")) + (String("")) + (String("")) + (String(""))))).length();
        if (_disp8oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp8oldLength = _dispTempLength1;
        _lcd1.setCursor(0, 0);
        _lcd1.print((((_MenuBlock_248462490_MNO) + (String(" ")) + (_MenuBlock_248462490_VNO) + (String(" ")) + (_MenuBlock_248462490_ASO_1) + (String(" ")) + (String("")) + (String("")) + (String("")))));
    }
     else 
    {
        if (_disp8oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp8oldLength = 0;
        }
    }
    //Плата:2
//Наименование:ВКЛ. НАГРУЗКИ 5 - 8
    if(((((!(_bounseInputD10O)) && (!(_bounseInputD17O)))) || (_gtv17))) _trgr4 = 0;
    if(((!(_bounseInputD10O)) && (!(!(_bounseInputD17O))))) _trgr4 = 1;
    if(!((_trgr4)==(_SV5CP0)))
    {
        _SV5CP0needSend = 1;
    }
     _SV5CP0 = _trgr4;
    if (_trgr4) 
    {
         if (! _gen4I) 
        {
            _gen4I = 1;
            _gen4O = 1;
            _gen4P = millis();
        }
    }
     else 
    {
        _gen4I = 0 ;
        _gen4O= 0;
    }
    if (_gen4I) 
    {
          if (flprog::isTimer (_gen4P , 500)) 
        {
             _gen4P = millis();
            _gen4O = ! _gen4O;
        }
    }
    if (((_gtv8) || (((((!(_bounseInputD10O)) && (!(_bounseInputD17O)))) || (_gtv17)))))
    {
        _count9_Value = 0;
    }
     else 
    {
        if (_gen4O)
        {
            if (! _count9I) 
            {
                _count9I = 1;
                _count9_Value = _count9_Value + 1;
            }
        }
         else 
        {
            _count9I = 0;
        }
    }
    _count9MaxLO = _count9_Value >= 60;
    if (_gtv17)
    {
        _count10_Value = 0;
    }
     else 
    {
        if (_gtv8)
        {
            if (! _count10I) 
            {
                _count10I = 1;
                if(_count10_Value < 24) 
                {
                    _count10_Value = _count10_Value + 1;
                }
            }
        }
         else 
        {
            _count10I = 0;
        }
    }
    if ((((_count10_Value) == ((readIntegerFromEEPROM(16, 0, 0x0)))) && ((_count9_Value) == ((readIntegerFromEEPROM(18, 0, 0x0)))))) 
    {
        if (! _gen9I)
        {
            _gen9I = 1;
            _gen9O = 1;
            _gen9P = millis();
        }
    }
     else 
    {
        _gen9I = 0 ;
        _gen9O= 0;
    }
     if (_gen9I &&  _gen9O)   _gen9O = !(flprog::isTimer(_gen9P , 300));
    _gtv17 = _gen9O;
    if (_trgr4) 
    {
         if (! _gen21I) 
        {
            _gen21I = 1;
            _gen21O = 1;
            _gen21P = millis();
        }
    }
     else 
    {
        _gen21I = 0 ;
        _gen21O= 0;
    }
    if (_gen21I) 
    {
          if (flprog::isTimer (_gen21P , 500)) 
        {
             _gen21P = millis();
            _gen21O = ! _gen21O;
        }
    }
    if(_gen21O)
    {
        _swi5=String(" ");
    }
    else
    {
        _swi5=String(":");
    }
    if (_Terminal_207235935) 
    {
        _dispTempLength1 = ((((String("LOAD5 ")) + ((String(_count10_Value, DEC))) + (_swi5) + ((String(_count9_Value, DEC))) + (String("  ")) + (_Terminal_211597712)))).length();
        if (_disp3oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp3oldLength = _dispTempLength1;
        _lcd1.setCursor(0, 0);
        _lcd1.print((((String("LOAD5 ")) + ((String(_count10_Value, DEC))) + (_swi5) + ((String(_count9_Value, DEC))) + (String("  ")) + (_Terminal_211597712))));
    }
     else 
    {
        if (_disp3oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp3oldLength = 0;
        }
    }
    _gtv8 = _count9MaxLO;
    if(((((!(_bounseInputD9O)) && (!(_bounseInputD17O)))) || (_gtv18))) _trgr5 = 0;
    if(((!(_bounseInputD9O)) && (!(!(_bounseInputD17O))))) _trgr5 = 1;
    if(!((_trgr5)==(_SV6CP0)))
    {
        _SV6CP0needSend = 1;
    }
     _SV6CP0 = _trgr5;
    if (_trgr5) 
    {
         if (! _gen5I) 
        {
            _gen5I = 1;
            _gen5O = 1;
            _gen5P = millis();
        }
    }
     else 
    {
        _gen5I = 0 ;
        _gen5O= 0;
    }
    if (_gen5I) 
    {
          if (flprog::isTimer (_gen5P , 500)) 
        {
             _gen5P = millis();
            _gen5O = ! _gen5O;
        }
    }
    if (((_gtv9) || (((((!(_bounseInputD9O)) && (!(_bounseInputD17O)))) || (_gtv18)))))
    {
        _count11_Value = 0;
    }
     else 
    {
        if (_gen5O)
        {
            if (! _count11I) 
            {
                _count11I = 1;
                _count11_Value = _count11_Value + 1;
            }
        }
         else 
        {
            _count11I = 0;
        }
    }
    _count11MaxLO = _count11_Value >= 60;
    if (_gtv18)
    {
        _count13_Value = 0;
    }
     else 
    {
        if (_gtv9)
        {
            if (! _count13I) 
            {
                _count13I = 1;
                if(_count13_Value < 24) 
                {
                    _count13_Value = _count13_Value + 1;
                }
            }
        }
         else 
        {
            _count13I = 0;
        }
    }
    if ((((_count13_Value) == ((readIntegerFromEEPROM(20, 0, 0x0)))) && ((_count11_Value) == ((readIntegerFromEEPROM(22, 0, 0x0)))))) 
    {
        if (! _gen14I)
        {
            _gen14I = 1;
            _gen14O = 1;
            _gen14P = millis();
        }
    }
     else 
    {
        _gen14I = 0 ;
        _gen14O= 0;
    }
     if (_gen14I &&  _gen14O)   _gen14O = !(flprog::isTimer(_gen14P , 300));
    _gtv18 = _gen14O;
    if (_trgr5) 
    {
         if (! _gen22I) 
        {
            _gen22I = 1;
            _gen22O = 1;
            _gen22P = millis();
        }
    }
     else 
    {
        _gen22I = 0 ;
        _gen22O= 0;
    }
    if (_gen22I) 
    {
          if (flprog::isTimer (_gen22P , 500)) 
        {
             _gen22P = millis();
            _gen22O = ! _gen22O;
        }
    }
    if(_gen22O)
    {
        _swi6=String(" ");
    }
    else
    {
        _swi6=String(":");
    }
    if (_Terminal_207235935) 
    {
        _dispTempLength1 = ((((String("LOAD6 ")) + ((String(_count13_Value, DEC))) + (_swi6) + ((String(_count11_Value, DEC))) + (String("  ")) + (_Terminal_213262237)))).length();
        if (_disp4oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp4oldLength = _dispTempLength1;
        _lcd1.setCursor(0, 1);
        _lcd1.print((((String("LOAD6 ")) + ((String(_count13_Value, DEC))) + (_swi6) + ((String(_count11_Value, DEC))) + (String("  ")) + (_Terminal_213262237))));
    }
     else 
    {
        if (_disp4oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp4oldLength = 0;
        }
    }
    _gtv9 = _count11MaxLO;
    if(((((!(_bounseInputD8O)) && (!(_bounseInputD17O)))) || (_gtv19))) _trgr7 = 0;
    if(((!(_bounseInputD8O)) && (!(!(_bounseInputD17O))))) _trgr7 = 1;
    if(!((_trgr7)==(_SV7CP0)))
    {
        _SV7CP0needSend = 1;
    }
     _SV7CP0 = _trgr7;
    if (_trgr7) 
    {
         if (! _gen7I) 
        {
            _gen7I = 1;
            _gen7O = 1;
            _gen7P = millis();
        }
    }
     else 
    {
        _gen7I = 0 ;
        _gen7O= 0;
    }
    if (_gen7I) 
    {
          if (flprog::isTimer (_gen7P , 500)) 
        {
             _gen7P = millis();
            _gen7O = ! _gen7O;
        }
    }
    if (((_gtv10) || (((((!(_bounseInputD8O)) && (!(_bounseInputD17O)))) || (_gtv19)))))
    {
        _count14_Value = 0;
    }
     else 
    {
        if (_gen7O)
        {
            if (! _count14I) 
            {
                _count14I = 1;
                _count14_Value = _count14_Value + 1;
            }
        }
         else 
        {
            _count14I = 0;
        }
    }
    _count14MaxLO = _count14_Value >= 60;
    if (_gtv19)
    {
        _count15_Value = 0;
    }
     else 
    {
        if (_gtv10)
        {
            if (! _count15I) 
            {
                _count15I = 1;
                if(_count15_Value < 24) 
                {
                    _count15_Value = _count15_Value + 1;
                }
            }
        }
         else 
        {
            _count15I = 0;
        }
    }
    if ((((_count15_Value) == ((readIntegerFromEEPROM(24, 0, 0x0)))) && ((_count14_Value) == ((readIntegerFromEEPROM(26, 0, 0x0)))))) 
    {
        if (! _gen15I)
        {
            _gen15I = 1;
            _gen15O = 1;
            _gen15P = millis();
        }
    }
     else 
    {
        _gen15I = 0 ;
        _gen15O= 0;
    }
     if (_gen15I &&  _gen15O)   _gen15O = !(flprog::isTimer(_gen15P , 300));
    _gtv19 = _gen15O;
    if (_trgr7) 
    {
         if (! _gen23I) 
        {
            _gen23I = 1;
            _gen23O = 1;
            _gen23P = millis();
        }
    }
     else 
    {
        _gen23I = 0 ;
        _gen23O= 0;
    }
    if (_gen23I) 
    {
          if (flprog::isTimer (_gen23P , 500)) 
        {
             _gen23P = millis();
            _gen23O = ! _gen23O;
        }
    }
    if(_gen23O)
    {
        _swi7=String(" ");
    }
    else
    {
        _swi7=String(":");
    }
    if (_Terminal_207235935) 
    {
        _dispTempLength1 = ((((String("LOAD7 ")) + ((String(_count15_Value, DEC))) + (_swi7) + ((String(_count14_Value, DEC))) + (String("  ")) + (_Terminal_214926762)))).length();
        if (_disp5oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp5oldLength = _dispTempLength1;
        _lcd1.setCursor(0, 2);
        _lcd1.print((((String("LOAD7 ")) + ((String(_count15_Value, DEC))) + (_swi7) + ((String(_count14_Value, DEC))) + (String("  ")) + (_Terminal_214926762))));
    }
     else 
    {
        if (_disp5oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp5oldLength = 0;
        }
    }
    _gtv10 = _count14MaxLO;
    if (_gtv2) 
    {
        if (! _gen16I)
        {
            _gen16I = 1;
            _gen16O = 1;
            _gen16P = millis();
        }
    }
     else 
    {
        _gen16I = 0 ;
        _gen16O= 0;
    }
     if (_gen16I &&  _gen16O)   _gen16O = !(flprog::isTimer(_gen16P , 300));
    _gtv20 = _gen16O;
    if(((((!(_bounseInputD7O)) && (!(_bounseInputD17O)))) || (_gen16O))) _trgr8 = 0;
    if(((!(_bounseInputD7O)) && (!(!(_bounseInputD17O))))) _trgr8 = 1;
    if (_trgr8) 
    {
         if (! _gen8I) 
        {
            _gen8I = 1;
            _gen8O = 1;
            _gen8P = millis();
        }
    }
     else 
    {
        _gen8I = 0 ;
        _gen8O= 0;
    }
    if (_gen8I) 
    {
          if (flprog::isTimer (_gen8P , 500)) 
        {
             _gen8P = millis();
            _gen8O = ! _gen8O;
        }
    }
    if (((_gtv11) || (((((!(_bounseInputD7O)) && (!(_bounseInputD17O)))) || (_gen16O)))))
    {
        _count16_Value = 0;
    }
     else 
    {
        if (_gen8O)
        {
            if (! _count16I) 
            {
                _count16I = 1;
                _count16_Value = _count16_Value + 1;
            }
        }
         else 
        {
            _count16I = 0;
        }
    }
    _count16MaxLO = _count16_Value >= 60;
    if (_gtv20)
    {
        _count17_Value = 0;
    }
     else 
    {
        if (_gtv11)
        {
            if (! _count17I) 
            {
                _count17I = 1;
                if(_count17_Value < 24) 
                {
                    _count17_Value = _count17_Value + 1;
                }
            }
        }
         else 
        {
            _count17I = 0;
        }
    }
    _gtv2 = (((_count17_Value) == ((readIntegerFromEEPROM(28, 0, 0x0)))) && ((_count16_Value) == ((readIntegerFromEEPROM(30, 0, 0x0)))));
    if (_trgr8) 
    {
         if (! _gen24I) 
        {
            _gen24I = 1;
            _gen24O = 1;
            _gen24P = millis();
        }
    }
     else 
    {
        _gen24I = 0 ;
        _gen24O= 0;
    }
    if (_gen24I) 
    {
          if (flprog::isTimer (_gen24P , 500)) 
        {
             _gen24P = millis();
            _gen24O = ! _gen24O;
        }
    }
    if(_gen24O)
    {
        _swi8=String(" ");
    }
    else
    {
        _swi8=String(":");
    }
    if (_Terminal_207235935) 
    {
        _dispTempLength1 = ((((String("LOAD8 ")) + ((String(_count17_Value, DEC))) + (_swi8) + ((String(_count16_Value, DEC))) + (String("  ")) + (_Terminal_216591287)))).length();
        if (_disp6oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp6oldLength = _dispTempLength1;
        _lcd1.setCursor(0, 3);
        _lcd1.print((((String("LOAD8 ")) + ((String(_count17_Value, DEC))) + (_swi8) + ((String(_count16_Value, DEC))) + (String("  ")) + (_Terminal_216591287))));
    }
     else 
    {
        if (_disp6oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp6oldLength = 0;
        }
    }
    _gtv11 = _count16MaxLO;
    if(!((_trgr8)==(_SV8CP0)))
    {
        _SV8CP0needSend = 1;
    }
     _SV8CP0 = _trgr8;
    //Плата:3
//Наименование:ЗАПИСЬ МАКС. ВРЕМЕНИ В ПАМЯТЬ
    _Terminal_204939612 = (((String((readIntegerFromEEPROM(0, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(2, 0, 0x0)), DEC))) + (String("m")));
    if (((_Terminal_219153375) && (((_MenuBlock_248462490_MNO).equals(String("LOAD1")))))) 
    {
        _dispTempLength1 = (((((String((readIntegerFromEEPROM(0, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(2, 0, 0x0)), DEC))) + (String("m"))))).length();
        if (_disp12oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp12oldLength = _dispTempLength1;
        _lcd1.setCursor(13, 0);
        _lcd1.print(((((String((readIntegerFromEEPROM(0, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(2, 0, 0x0)), DEC))) + (String("m")))));
    }
     else 
    {
        if (_disp12oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp12oldLength = 0;
        }
    }
    _Terminal_206604137 = (((String((readIntegerFromEEPROM(4, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(6, 0, 0x0)), DEC))) + (String("m")));
    if (((_Terminal_219153375) && (((_MenuBlock_248462490_MNO).equals(String("LOAD2")))))) 
    {
        _dispTempLength1 = (((((String((readIntegerFromEEPROM(4, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(6, 0, 0x0)), DEC))) + (String("m"))))).length();
        if (_disp9oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp9oldLength = _dispTempLength1;
        _lcd1.setCursor(13, 0);
        _lcd1.print(((((String((readIntegerFromEEPROM(4, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(6, 0, 0x0)), DEC))) + (String("m")))));
    }
     else 
    {
        if (_disp9oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp9oldLength = 0;
        }
    }
    _Terminal_208268662 = (((String((readIntegerFromEEPROM(8, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(10, 0, 0x0)), DEC))) + (String("m")));
    if (((_Terminal_219153375) && (((_MenuBlock_248462490_MNO).equals(String("LOAD3")))))) 
    {
        _dispTempLength1 = (((((String((readIntegerFromEEPROM(8, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(10, 0, 0x0)), DEC))) + (String("m"))))).length();
        if (_disp10oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp10oldLength = _dispTempLength1;
        _lcd1.setCursor(13, 0);
        _lcd1.print(((((String((readIntegerFromEEPROM(8, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(10, 0, 0x0)), DEC))) + (String("m")))));
    }
     else 
    {
        if (_disp10oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp10oldLength = 0;
        }
    }
    _Terminal_209933187 = (((String((readIntegerFromEEPROM(12, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(14, 0, 0x0)), DEC))) + (String("m")));
    if (((_Terminal_219153375) && (((_MenuBlock_248462490_MNO).equals(String("LOAD4")))))) 
    {
        _dispTempLength1 = (((((String((readIntegerFromEEPROM(12, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(14, 0, 0x0)), DEC))) + (String("m"))))).length();
        if (_disp11oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp11oldLength = _dispTempLength1;
        _lcd1.setCursor(13, 0);
        _lcd1.print(((((String((readIntegerFromEEPROM(12, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(14, 0, 0x0)), DEC))) + (String("m")))));
    }
     else 
    {
        if (_disp11oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp11oldLength = 0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD1")))) && (((_MenuBlock_248462490_ASO_1).equals(String("H")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR19OSN)
        {
            (updateIntegerToEEPROM(0, 0, 0x0, ((_menuValueArray_int[4]))));
            _SEEPR19OSN=1;
        }
    }
    else
    {
         if(_SEEPR19OSN)
        {
            _SEEPR19OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD1")))) && (((_MenuBlock_248462490_ASO_1).equals(String("MIN")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR1OSN)
        {
            (updateIntegerToEEPROM(2, 0, 0x0, ((_menuValueArray_int[10]))));
            _SEEPR1OSN=1;
        }
    }
    else
    {
         if(_SEEPR1OSN)
        {
            _SEEPR1OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD2")))) && (((_MenuBlock_248462490_ASO_1).equals(String("H")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR2OSN)
        {
            (updateIntegerToEEPROM(4, 0, 0x0, ((_menuValueArray_int[8]))));
            _SEEPR2OSN=1;
        }
    }
    else
    {
         if(_SEEPR2OSN)
        {
            _SEEPR2OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD2")))) && (((_MenuBlock_248462490_ASO_1).equals(String("MIN")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR3OSN)
        {
            (updateIntegerToEEPROM(6, 0, 0x0, ((_menuValueArray_int[5]))));
            _SEEPR3OSN=1;
        }
    }
    else
    {
         if(_SEEPR3OSN)
        {
            _SEEPR3OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD3")))) && (((_MenuBlock_248462490_ASO_1).equals(String("H")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR4OSN)
        {
            (updateIntegerToEEPROM(8, 0, 0x0, ((_menuValueArray_int[3]))));
            _SEEPR4OSN=1;
        }
    }
    else
    {
         if(_SEEPR4OSN)
        {
            _SEEPR4OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD3")))) && (((_MenuBlock_248462490_ASO_1).equals(String("MIN")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR5OSN)
        {
            (updateIntegerToEEPROM(10, 0, 0x0, ((_menuValueArray_int[1]))));
            _SEEPR5OSN=1;
        }
    }
    else
    {
         if(_SEEPR5OSN)
        {
            _SEEPR5OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD4")))) && (((_MenuBlock_248462490_ASO_1).equals(String("H")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR6OSN)
        {
            (updateIntegerToEEPROM(12, 0, 0x0, ((_menuValueArray_int[0]))));
            _SEEPR6OSN=1;
        }
    }
    else
    {
         if(_SEEPR6OSN)
        {
            _SEEPR6OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD4")))) && (((_MenuBlock_248462490_ASO_1).equals(String("MIN")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR7OSN)
        {
            (updateIntegerToEEPROM(14, 0, 0x0, ((_menuValueArray_int[15]))));
            _SEEPR7OSN=1;
        }
    }
    else
    {
         if(_SEEPR7OSN)
        {
            _SEEPR7OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD5")))) && (((_MenuBlock_248462490_ASO_1).equals(String("H")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR8OSN)
        {
            (updateIntegerToEEPROM(16, 0, 0x0, ((_menuValueArray_int[13]))));
            _SEEPR8OSN=1;
        }
    }
    else
    {
         if(_SEEPR8OSN)
        {
            _SEEPR8OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD5")))) && (((_MenuBlock_248462490_ASO_1).equals(String("MIN")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR9OSN)
        {
            (updateIntegerToEEPROM(18, 0, 0x0, ((_menuValueArray_int[12]))));
            _SEEPR9OSN=1;
        }
    }
    else
    {
         if(_SEEPR9OSN)
        {
            _SEEPR9OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD6")))) && (((_MenuBlock_248462490_ASO_1).equals(String("H")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR10OSN)
        {
            (updateIntegerToEEPROM(20, 0, 0x0, ((_menuValueArray_int[11]))));
            _SEEPR10OSN=1;
        }
    }
    else
    {
         if(_SEEPR10OSN)
        {
            _SEEPR10OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD6")))) && (((_MenuBlock_248462490_ASO_1).equals(String("MIN")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR11OSN)
        {
            (updateIntegerToEEPROM(22, 0, 0x0, ((_menuValueArray_int[9]))));
            _SEEPR11OSN=1;
        }
    }
    else
    {
         if(_SEEPR11OSN)
        {
            _SEEPR11OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD7")))) && (((_MenuBlock_248462490_ASO_1).equals(String("H")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR12OSN)
        {
            (updateIntegerToEEPROM(24, 0, 0x0, ((_menuValueArray_int[7]))));
            _SEEPR12OSN=1;
        }
    }
    else
    {
         if(_SEEPR12OSN)
        {
            _SEEPR12OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD7")))) && (((_MenuBlock_248462490_ASO_1).equals(String("MIN")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR13OSN)
        {
            (updateIntegerToEEPROM(26, 0, 0x0, ((_menuValueArray_int[6]))));
            _SEEPR13OSN=1;
        }
    }
    else
    {
         if(_SEEPR13OSN)
        {
            _SEEPR13OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD8")))) && (((_MenuBlock_248462490_ASO_1).equals(String("H")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR14OSN)
        {
            (updateIntegerToEEPROM(28, 0, 0x0, ((_menuValueArray_int[2]))));
            _SEEPR14OSN=1;
        }
    }
    else
    {
         if(_SEEPR14OSN)
        {
            _SEEPR14OSN=0;
        }
    }
    if(((((_MenuBlock_248462490_MNO).equals(String("LOAD8")))) && (((_MenuBlock_248462490_ASO_1).equals(String("MIN")))) && (!(_bounseInputD2O))))
    {
         if(!_SEEPR15OSN)
        {
            (updateIntegerToEEPROM(30, 0, 0x0, ((_menuValueArray_int[14]))));
            _SEEPR15OSN=1;
        }
    }
    else
    {
         if(_SEEPR15OSN)
        {
            _SEEPR15OSN=0;
        }
    }
    _Terminal_211597712 = (((String((readIntegerFromEEPROM(16, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(18, 0, 0x0)), DEC))) + (String("m")));
    if (((_Terminal_219153375) && (((_MenuBlock_248462490_MNO).equals(String("LOAD5")))))) 
    {
        _dispTempLength1 = (((((String((readIntegerFromEEPROM(16, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(18, 0, 0x0)), DEC))) + (String("m"))))).length();
        if (_disp13oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp13oldLength = _dispTempLength1;
        _lcd1.setCursor(13, 0);
        _lcd1.print(((((String((readIntegerFromEEPROM(16, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(18, 0, 0x0)), DEC))) + (String("m")))));
    }
     else 
    {
        if (_disp13oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp13oldLength = 0;
        }
    }
    _Terminal_213262237 = (((String((readIntegerFromEEPROM(20, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(22, 0, 0x0)), DEC))) + (String("m")));
    if (((_Terminal_219153375) && (((_MenuBlock_248462490_MNO).equals(String("LOAD6")))))) 
    {
        _dispTempLength1 = (((((String((readIntegerFromEEPROM(20, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(22, 0, 0x0)), DEC))) + (String("m"))))).length();
        if (_disp14oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp14oldLength = _dispTempLength1;
        _lcd1.setCursor(13, 0);
        _lcd1.print(((((String((readIntegerFromEEPROM(20, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(22, 0, 0x0)), DEC))) + (String("m")))));
    }
     else 
    {
        if (_disp14oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp14oldLength = 0;
        }
    }
    _Terminal_214926762 = (((String((readIntegerFromEEPROM(24, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(26, 0, 0x0)), DEC))) + (String("m")));
    if (((_Terminal_219153375) && (((_MenuBlock_248462490_MNO).equals(String("LOAD7")))))) 
    {
        _dispTempLength1 = (((((String((readIntegerFromEEPROM(24, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(26, 0, 0x0)), DEC))) + (String("m"))))).length();
        if (_disp15oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp15oldLength = _dispTempLength1;
        _lcd1.setCursor(13, 0);
        _lcd1.print(((((String((readIntegerFromEEPROM(24, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(26, 0, 0x0)), DEC))) + (String("m")))));
    }
     else 
    {
        if (_disp15oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp15oldLength = 0;
        }
    }
    _Terminal_216591287 = (((String((readIntegerFromEEPROM(28, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(30, 0, 0x0)), DEC))) + (String("m")));
    if (((_Terminal_219153375) && (((_MenuBlock_248462490_MNO).equals(String("LOAD8")))))) 
    {
        _dispTempLength1 = (((((String((readIntegerFromEEPROM(28, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(30, 0, 0x0)), DEC))) + (String("m"))))).length();
        if (_disp17oldLength > _dispTempLength1) 
        {
            _isNeedClearDisp1 = 1;
        }
        _disp17oldLength = _dispTempLength1;
        _lcd1.setCursor(13, 0);
        _lcd1.print(((((String((readIntegerFromEEPROM(28, 0, 0x0)), DEC))) + (String("h")) + (String(" ")) + ((String((readIntegerFromEEPROM(30, 0, 0x0)), DEC))) + (String("m")))));
    }
     else 
    {
        if (_disp17oldLength > 0) 
        {
            _isNeedClearDisp1 = 1;
            _disp17oldLength = 0;
        }
    }
    //Плата:4
    if(_SV1CP0needSend) 
    {
        _SV1CP0needSend = 0;
        Serial.write (1);
        Serial.print (1);
        Serial.write (2);
        Serial.print (_SV1CP0);
        Serial.write (3);
    }
    if(_SV2CP0needSend) 
    {
        _SV2CP0needSend = 0;
        Serial.write (1);
        Serial.print (2);
        Serial.write (2);
        Serial.print (_SV2CP0);
        Serial.write (3);
    }
    if(_SV3CP0needSend) 
    {
        _SV3CP0needSend = 0;
        Serial.write (1);
        Serial.print (3);
        Serial.write (2);
        Serial.print (_SV3CP0);
        Serial.write (3);
    }
    if(_SV4CP0needSend) 
    {
        _SV4CP0needSend = 0;
        Serial.write (1);
        Serial.print (4);
        Serial.write (2);
        Serial.print (_SV4CP0);
        Serial.write (3);
    }
    if(_SV5CP0needSend) 
    {
        _SV5CP0needSend = 0;
        Serial.write (1);
        Serial.print (5);
        Serial.write (2);
        Serial.print (_SV5CP0);
        Serial.write (3);
    }
    if(_SV6CP0needSend) 
    {
        _SV6CP0needSend = 0;
        Serial.write (1);
        Serial.print (6);
        Serial.write (2);
        Serial.print (_SV6CP0);
        Serial.write (3);
    }
    if(_SV7CP0needSend) 
    {
        _SV7CP0needSend = 0;
        Serial.write (1);
        Serial.print (7);
        Serial.write (2);
        Serial.print (_SV7CP0);
        Serial.write (3);
    }
    if(_SV8CP0needSend) 
    {
        _SV8CP0needSend = 0;
        Serial.write (1);
        Serial.print (8);
        Serial.write (2);
        Serial.print (_SV8CP0);
        Serial.write (3);
    }
}
String _readStringFromProgmem (char *string)
{
    String result = String("");
    while (pgm_read_byte(string)!='\0')
    {
        result=result+ char(pgm_read_byte(string));
        	string++;
        	
    }
    return result;
}
void _menuUpEvents (int menuIndex)
{
    int tempIndex = pgm_read_byte(&_menuParametrsArray[((_MainMenus[menuIndex]).currentItem).startInArrayIndex]);
    int parIndex = pgm_read_byte(&_menuParametrsArray[ (((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+5]);
    int parentStartIndex;
    int parentStopIndex;
    if (parIndex == 0) 
    {
        parentStartIndex = (_MainMenus[menuIndex]).startIndex;
        parentStopIndex =(_MainMenus[menuIndex]).stopIndex;
    }
    else 
    {
        parentStartIndex = pgm_read_byte(&_menuParametrsArray[((_MenuItems[parIndex - 1]).startInArrayIndex)+3]);
        parentStopIndex = pgm_read_byte(&_menuParametrsArray[((_MenuItems[parIndex-1]).startInArrayIndex)+4]);
    }
    if (tempIndex == parentStartIndex) 
    {
        if((_MainMenus[menuIndex]).isSwitchMenuAroundRing) 
        {
            (_MainMenus[menuIndex]).currentItem = _MenuItems[parentStopIndex -1];
            return;
        }
         else
        {
            return;
        }
    }
    (_MainMenus[menuIndex]).currentItem = _MenuItems[tempIndex - 2];
    return;
}
void _menuDownEvents (int menuIndex)
{
    int tempIndex = pgm_read_byte(&_menuParametrsArray[((_MainMenus[menuIndex]).currentItem).startInArrayIndex]);
    int parIndex = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+5]);
    int parentStartIndex;
    int parentStopIndex;
    if (parIndex == 0) 
    {
        parentStartIndex = (_MainMenus[menuIndex]).startIndex;
        parentStopIndex =(_MainMenus[menuIndex]).stopIndex;
    }
    else 
    {
        parentStartIndex = pgm_read_byte(&_menuParametrsArray[((_MenuItems[parIndex-1]).startInArrayIndex)+3]);
        parentStopIndex = pgm_read_byte(&_menuParametrsArray[((_MenuItems[parIndex-1]).startInArrayIndex)+4]);
    }
    if (tempIndex == parentStopIndex) 
    {
        if((_MainMenus[menuIndex]).isSwitchMenuAroundRing) 
        {
            (_MainMenus[menuIndex]).currentItem = _MenuItems[parentStartIndex -1];
            return;
        }
         else
        {
            return;
        }
    }
    (_MainMenus[menuIndex]).currentItem = _MenuItems[tempIndex];
    return;
}
void _valueUpEvents (int menuIndex)
{
    int valIndex = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+2]);
    int itemType = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+1]);
    int indexMax = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+6]);
    int indexStep = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+8]);
    if (itemType == 4) 
    {
        if (! indexMax == 0) 
        {
             if (! (int(pgm_read_word(&_menuConstantValuesArray_int[indexMax -1])) > int(_menuValueArray_int[valIndex -1]))) 
            {
                return;
            }
        }
        _menuValueArray_int[valIndex -1] = _menuValueArray_int[valIndex -1] + (pgm_read_word(&_menuConstantValuesArray_int[indexStep -1]));
    }
}
void _valueDownEvents (int menuIndex)
{
    int valIndex = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+2]);
    int itemType = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+1]);
    int indexMin = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+7]);
    int indexStep = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+8]);
    if (itemType == 4) 
    {
        if (! indexMin == 0) 
        {
             if (! ((int(pgm_read_word(&_menuConstantValuesArray_int[indexMin - 1]))) < int(_menuValueArray_int[valIndex - 1]))) 
            {
                return;
            }
        }
        _menuValueArray_int[valIndex - 1] = _menuValueArray_int[valIndex - 1] - (pgm_read_word(&_menuConstantValuesArray_int[indexStep - 1]));
    }
}
String _menuOutputValueString (int menuIndex)
{
    int itemType = pgm_read_byte(&_menuParametrsArray[ (((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+1]);
    int valIndex = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+2]);
    int indexMin = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+7]);
    int indexMax = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+6]);
    if(valIndex == 0)
    {
         return "";
    }
    int convFormat = pgm_read_byte(&_menuParametrsArray[(((_MainMenus[menuIndex]).currentItem).startInArrayIndex)+9]);
    if(itemType == 4) 
    {
         return _convertNamber(itemType, convFormat, valIndex, indexMax, indexMin);
    }
    return "";
}
String _convertNamber(int itemType, int convFormat, int valIndex, int indexMax, int indexMin)
{
    if (itemType== 4) 
    {
        if (convFormat == 4) 
        {
             return String((_menuValueArray_int[valIndex - 1 ]),DEC);
        }
        if (convFormat == 5) 
        {
             return String((_menuValueArray_int[valIndex - 1]),HEX);
        }
        if (convFormat == 6) 
        {
             return String((_menuValueArray_int[valIndex -1]),BIN);
        }
    }
    return "";
}
byte readByteFromEEPROM(int addres, byte bitAddres, byte chipAddres)
{
    return EEPROM.read(addres);
}
void updateByteToEEPROM(int addres, byte bitAddres, byte chipAddres, byte value)
{
    return EEPROM.update(addres, value);
}
int readIntegerFromEEPROM(int addres, byte bitAddres, byte chipAddres)
{
    byte hight = readByteFromEEPROM(addres,  bitAddres,  chipAddres);
    byte low = readByteFromEEPROM((addres+1),  bitAddres,  chipAddres);
    return  word(hight, low);
}
void updateIntegerToEEPROM(int addres, byte bitAddres, byte chipAddres, int value)
{
    updateByteToEEPROM(addres,  bitAddres,  chipAddres, highByte(value));
    updateByteToEEPROM((addres+1),  bitAddres,  chipAddres, lowByte(value));
}
void _startUart0()
{
    int code= 6;
    Serial.begin(9600, (flprog::serialModeFromInt(code)));
}
